/*------------------------------
 *
 * iQ[
 *
 * camera wb_[
 * J𓮂
 *
------------------------------*/

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// DxLib wb_[

#include "camera.h"								// camera wb_[
#include "main.h"								// main wb_[

#define _USE_MATH_DEFINES
#include <math.h>								// Zp

/*------------------------------
 * LOCAL PARAMETER
------------------------------*/
int camera_state, camera_time; 

void initCameraPos(void)
{
	SetCameraPositionAndTarget_UpVecY( VGet( -20.0f, 8.5f, 0.0f ), VGet( 0.0f, 8.5f, 0.0f ) );

	camera_state = CAMERA_NORMAL;
	camera_time = 0;
}
void updateCamera(void)
{
	switch( camera_state )
	{
	case CAMERA_NORMAL:
		SetCameraPositionAndTarget_UpVecY( VGet( -20.0f, 8.5f, 0.0f ), VGet( 0.0f, 8.5f, 0.0f ) );
		break;
	case CAMERA_AIR:
		{
			double deg = (double)camera_time / CAMERA_AIR_TIME * M_PI * 2; 
			SetCameraPositionAndTarget_UpVecY( VGet( -15.0f - 5.0f*camera_time/CAMERA_AIR_TIME, 8.5f, 0.0f ), VGet( 0.0f, 10.0f - 1.5f*cos(deg), 0.0f ) );
			if( camera_time++ >= CAMERA_AIR_TIME ) initCameraPos();
			return;
		}
	case CAMERA_ZOOMIN:
		SetCameraPositionAndTarget_UpVecY( VGet( -12.0f, 9.5f, 0.0f ), VGet( 0.0f, 9.5f, 0.0f ) );
		if( camera_time++ >= CAMERA_ZOOMIN_TIME ) initCameraPos();
		return;
	case CAMERA_ZOOMOUT:
		if( camera_time < CAMERA_ZOOMIN_TIME )
		{
			double deg = (double)camera_time / CAMERA_ZOOMOUT_TIME * M_PI / 2; 
			SetCameraPositionAndTarget_UpVecY( VGet( -20.0f - 10.0f*sin(deg), 9.5f, 0.0f ), VGet( 0.0f, 9.5f, 0.0f ) );
			camera_time++;
		}
		else
			SetCameraPositionAndTarget_UpVecY( VGet( -30.0f, 9.5f, 0.0f ), VGet( 0.0f, 9.5f, 0.0f ) );		
		return;
	case CAMERA_LOOKDOWN:
		if( camera_time < CAMERA_LOOKDOWN_TIME )
		{
			double deg = (double)camera_time / CAMERA_LOOKDOWN_TIME * M_PI / 2; 
			SetCameraPositionAndTarget_UpVecY( VGet( -23.0f + 3.0f*cos(deg), 8.5f, 0.0f ), VGet( 0.0f, 4.5f + 4.0f*cos(deg), 0.0f ) );
			camera_time++;
		}
		else
			SetCameraPositionAndTarget_UpVecY( VGet( -23.0f, 8.5f, 0.0f ), VGet( 0.0f, 4.5f, 0.0f ) );		
	default:
		return;
	}
}
void setCameraState( int x )
{
	if( !MOVE_CAMERA || x < CAMERA_NORMAL || CAMERA_LOOKDOWN < x ) return;

	camera_state = x;
	camera_time = 0;
}
