/*------------------------------
 *
 * iQ[
 *
 * player wb_[
 * vC[̊ǗS
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define PLAYER_H								// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// Dxlib wb_[
#include "main.h"								// main wb_[

#include "player.h"								// player wb_[

#include "camera.h"								// camera wb_[
#include "fight.h"								// fight wb_[
#include "gamepad.h"							// gamepad wb_[
#include "key.h"								// key wb_[
#include "replay.h"								// replay wb_[

/*------------------------------
 * LOCAL PARAMETER
------------------------------*/
int playerModelHandle1,playerModelHandle2;		// vC[f
int playerAttachIndex1=-1,playerAttachIndex2=-1;// A^b`
double totalTime1,playTime1;					// Đ
double totalTime2,playTime2;

const int EFF_NUM = 8;
int *hitEffect, *grdEffect;						// GtFNg̉摜nh

/*------------------------------
 * ֐ loadPlayerGraph, loadPlayerGraph
 * vC[̉摜[h, A[h
------------------------------*/
void loadPlayerGraph(void)
{
	playerModelHandle1 = MV1LoadModel( "model/player_red.pmx" );
	playerModelHandle2 = MV1LoadModel( "model/player_blue.pmx" );
												// f̃[h

	// ʒuƉ]̐ݒ
	MV1SetPosition( playerModelHandle1, VGet( 0.0f, 0.0f, 4.25f ) ) ;
	MV1SetPosition( playerModelHandle2, VGet( 0.0f, 0.0f,-4.25f ) ) ;
    MV1SetRotationXYZ( playerModelHandle2, VGet( 0.0f, DX_PI_F, 0.0f ) ) ;

	hitEffect = new int[ EFF_NUM ];
	grdEffect = new int[ EFF_NUM ];

	for(int i=0;i<EFF_NUM;i++)
	{
		hitEffect[i] = -1;
		grdEffect[i] = -1;
	}

	LoadDivGraph( "effect/hit.png" , 8, 8, 1, 200, 200, hitEffect );
	LoadDivGraph( "effect/guard.png" , 8, 8, 1, 200, 200, grdEffect );

}
void unloadPlayerGraph(void)
{
	for(int i=0;i<EFF_NUM;i++)
	{
		if( hitEffect[i] == -1 ) DeleteGraph( hitEffect[i] );
		if( grdEffect[i] == -1 ) DeleteGraph( grdEffect[i] );
	}

	delete [] hitEffect; delete [] grdEffect; 
}

/*------------------------------
 * ֐ PLAYER::init
 * vC[̏s
------------------------------*/
void PLAYER::init( int num )
{
	player_num = num;

	HP = PLAYER_HP[ player_num-1 ];
	HPsub = PLAYER_HP[ player_num-1 ];
	moveThis( MOVEMENT_TACHI, STATUS_GUARD );
	time = -1;
	waza = -1;
	kouchoku = 0;
	precede = -1;
	KO_flag = 0;

	cant_move = TRUE;
	no_damage = TRUE;

	reversal_flag = 0;
	reversal_time = 0;
	critical_flag = 0;
	critical_time = 0;
}

/*------------------------------
 * ֐ PLAYER::update
 * vC[̍XVs
------------------------------*/
void PLAYER::update(void)
{
	time++;										// vC[̓Ԃ̃JE^

	decreaseHPsub();							// Q[W炷
	cdownBonus();								// {[iX\̊Ǘ
	walk();

	if( cant_move ) return;

	switch( move )								// ݂̏󋵂ɂ, Ăяo֐߂
	{
	case MOVEMENT_TACHI:
		whileTACHI();
		break;
	case MOVEMENT_ATTACK_JAB:
		whileATTACK_JAB();
		break;
	case MOVEMENT_ATTACK_STRAIGHT:
		whileATTACK_STRAIGHT();
		break;
	case MOVEMENT_ATTACK_HOOK:
		whileATTACK_HOOK();
		break;
	case MOVEMENT_ATTACK_UPPERCUT:
		whileATTACK_UPPERCUT();
		break;
	case MOVEMENT_YARARE_JAB:
	case MOVEMENT_YARARE_STRAIGHT:
	case MOVEMENT_YARARE_HOOK:
	case MOVEMENT_YARARE_UPPERCUT:
	case MOVEMENT_YARARE_AIUCHI:
	case MOVEMENT_GUARD_JAB:
	case MOVEMENT_GUARD_STRONG:
		whileKOUCHOKU();
		break;
	case MOVEMENT_KO_JAB:
	case MOVEMENT_KO_STRAIGHT:
	case MOVEMENT_KO_HOOK:
	case MOVEMENT_KO_UPPERCUT:
	default:
		break;
	}
}

/*------------------------------
 * ֐ PLAYER::output
 * vC[`ʂ
------------------------------*/
void PLAYER::output(void)
{
	if( player_num == 1 )
	{
		// ĐԂZbg
		MV1SetAttachAnimTime( playerModelHandle1, playerAttachIndex1, playTime1 ) ;
		playTime1 += 1.0f;
		if( !KO_flag && playTime1 >= totalTime1 ) playTime1 = 0.0f;

		MV1DrawModel( playerModelHandle1 ) ; // f̕`

		//DrawFormatString( 0,100, 0xffffff, "Model Handle : %d", playerModelHandle1 );
		//DrawFormatString( 0,120, 0xffffff, "Attach Index : %d", playerAttachIndex1 );
		//DrawFormatString( 0,140, 0xffffff, "Play Time / Total Time : %4.1lf / %4.1lf", playTime1, totalTime1 );
	}
	if( player_num == 2 )
	{
		// ĐԂZbg
		MV1SetAttachAnimTime( playerModelHandle2, playerAttachIndex2, playTime2 ) ;
		playTime2 += 1.0f;
		if( !KO_flag && playTime2 >= totalTime2 ) playTime2 = 0.0f;

		MV1DrawModel( playerModelHandle2 ) ; // f̕`
	}

	soundSE();
}

/*------------------------------
 * ֐ PLAYER::moveThis
 * ̓, ԂɈڍs
------------------------------*/
void PLAYER::moveThis( int mv, int st, int tm )
{
	move = mv;
	if( st != -1 ) status = st;
	if( tm != -1 ) time = tm;
	else time = 0;

	if( player_num == 1 )
	{
		if( playerAttachIndex1 != -1 ) MV1DetachAnim( playerModelHandle1, playerAttachIndex1 );

		playerAttachIndex1 = MV1AttachAnim( playerModelHandle1, mv, -1, FALSE ) ;
													// Aj[ṼA^b`
		totalTime1 = MV1GetAttachAnimTotalTime( playerModelHandle1, playerAttachIndex1 );
													// Aj[V̑ĐԂ擾
		playTime1 = time;							// ĐԂ̏
	}
	if( player_num == 2 )
	{
		if( playerAttachIndex2 != -1 ) MV1DetachAnim( playerModelHandle2, playerAttachIndex2 );

		playerAttachIndex2 = MV1AttachAnim( playerModelHandle2, mv, -1, FALSE ) ;
		totalTime2 = MV1GetAttachAnimTotalTime( playerModelHandle2, playerAttachIndex2 );
		playTime2 = time;
	}
}

/*------------------------------
 * ֐ PLAYER::while--
 * ̍Œ̏s
------------------------------*/
void PLAYER::whileTACHI(void)
{
	// UĂ邩̊mFƈڍs
	switch( checkAttack() )
	{
	case WAZA_JAB:
		moveThis( MOVEMENT_ATTACK_JAB, STATUS_BODDACHI );
		break;
	case WAZA_STRAIGHT:
		moveThis( MOVEMENT_ATTACK_STRAIGHT, STATUS_CRITICAL );
		break;
	case WAZA_HOOK:
		moveThis( MOVEMENT_ATTACK_HOOK, STATUS_BODDACHI );
		break;
	case WAZA_UPPERCUT:
		moveThis( MOVEMENT_ATTACK_UPPERCUT, STATUS_MUTEKI );
		break;
	default:
		break;
	}
}
void PLAYER::whileATTACK_JAB(void)
{
	// U̔
	if( time == FLAME_HASSEI_JAB )
	{
		waza = WAZA_JAB;
		status = STATUS_AIUCHI;
	}
	// s͎t
	if( time >= FLAME_ZENTAI_JAB - FLAME_SENKOU_NYUURYOKU )
	{
		checkPrecede();
	}
	// Z̏Iƈڍs
	if( time >= FLAME_ZENTAI_JAB )
	{
		whenMoveEnd();
	}
}
void PLAYER::whileATTACK_STRAIGHT(void)
{
	// U̔
	if( time == FLAME_HASSEI_STRAIGHT )
	{
		waza = WAZA_STRAIGHT;
		status = STATUS_AIUCHI;
	}
	// s͎t
	if( time >= FLAME_ZENTAI_STRAIGHT - FLAME_SENKOU_NYUURYOKU )
	{
		checkPrecede();
	}
	// Z̏Iƈڍs
	if( time >= FLAME_ZENTAI_STRAIGHT )
	{
		whenMoveEnd();
	}
}
void PLAYER::whileATTACK_HOOK(void)
{
	// U̔
	if( time == FLAME_HASSEI_HOOK )
	{
		waza = WAZA_HOOK;
		status = STATUS_AIUCHI;
	}
	// s͎t
	if( time >= FLAME_ZENTAI_HOOK - FLAME_SENKOU_NYUURYOKU )
	{
		checkPrecede();
	}
	// Z̏Iƈڍs
	if( time >= FLAME_ZENTAI_HOOK )
	{
		whenMoveEnd();
	}
}
void PLAYER::whileATTACK_UPPERCUT(void)
{
	// U̔
	if( time == FLAME_HASSEI_UPPERCUT )
	{
		waza = WAZA_UPPERCUT;
		// Abp[Jbg͔G
	}
	if( time == FLAME_HASSEI_UPPERCUT + 1 )
	{
		waza = WAZA_UPPERCUT;
		status = STATUS_CRITICAL;
		// Abp[Jbg͎
	}
	// s͎t
	if( time >= FLAME_ZENTAI_UPPERCUT - FLAME_SENKOU_NYUURYOKU )
	{
		checkPrecede();
	}
	// Z̏Iƈڍs
	if( time >= FLAME_ZENTAI_UPPERCUT )
	{
		whenMoveEnd();
	}
}
void PLAYER::whileKOUCHOKU(void)
{
	if( time >= kouchoku - FLAME_SENKOU_NYUURYOKU )
	{
		checkPrecede();
	}

	if( time >= kouchoku )					// 莞ԌoĂ΍d
	{
		kouchoku = 0;
		whenMoveEnd();
	}
}

/*------------------------------
 * ֐ PLAYER::whileMoveEnd
 * Uorh̏s
------------------------------*/
void PLAYER::whenMoveEnd(void)
{
	actionPrecede( MOVEMENT_TACHI, STATUS_GUARD );
}

/*------------------------------
 * ֐ PLAYER::actionPrecede
 * s͂̎s
------------------------------*/
void PLAYER::actionPrecede( int mv, int st )
{
	// o[T(orK[hɐs͂)
	if
	(
		precede != -1 &&
		( ( MOVEMENT_YARARE_JAB <= move && move <= MOVEMENT_YARARE_UPPERCUT ) || ( MOVEMENT_GUARD_JAB <= move && move <= MOVEMENT_GUARD_STRONG ) )
	)
		setBonus( BONUS_REVERSAL );

	// UĂ邩̊mFƈڍs
	switch( precede )
	{
	case WAZA_JAB:
		moveThis( MOVEMENT_ATTACK_JAB, STATUS_BODDACHI );
		break;
	case WAZA_STRAIGHT:
		moveThis( MOVEMENT_ATTACK_STRAIGHT, STATUS_CRITICAL );
		break;
	case WAZA_HOOK:
		moveThis( MOVEMENT_ATTACK_HOOK, STATUS_BODDACHI );
		break;
	case WAZA_UPPERCUT:
		moveThis( MOVEMENT_ATTACK_UPPERCUT, STATUS_MUTEKI );
		break;
	default:
		if( mv != -1 )
			moveThis( mv, st );
		break;
	}

	precede = -1;
}

/*------------------------------
 * ֐ PLAYER::checkPrecede
 * s͂̊mF
------------------------------*/
void PLAYER::checkPrecede(void)
{
	// UĂ邩̊mF
	if( checkAttack() != -1 ) precede = checkAttack();
}

/*------------------------------
 * ֐ PLAYER::checkAttack
 * U悤ƂĂ邩mF({^Ă邩)
------------------------------*/
int PLAYER::checkAttack(void)
{
	if( fight.getReplayMode() )
	{
		if( getReplayKeyState( player_num, 1 ) ) return WAZA_UPPERCUT;
		if( getReplayKeyState( player_num, 4 ) ) return WAZA_HOOK;
		if( getReplayKeyState( player_num, 3 ) ) return WAZA_STRAIGHT;
		if( getReplayKeyState( player_num, 2 ) ) return WAZA_JAB;
	}
	else
	{
		if( checkCommand1() ) return WAZA_UPPERCUT;
		if( checkCommand4() ) return WAZA_HOOK;
		if( checkCommand3() ) return WAZA_STRAIGHT;
		if( checkCommand2() ) return WAZA_JAB;
	}
	return -1;
}

/*------------------------------
 * ֐ PLAYER::checkCommand1,2,3,4
 * {^Ă邩ۂ̊mF
------------------------------*/
int PLAYER::checkCommand1(void)
{
	if( getPadNum() >= player_num )					// Q[pbhڑĂȂ
	{
		return getPadState( player_num, PAD_BUTTON1 );
	}
	else
	{
		if( player_num == 1 )
		{
			if( getKeyState( KEY_INPUT_W ) == 1 )
				return 1;
			else
				return 0;
		}
		else
		{
			if( getKeyState( KEY_INPUT_UP ) == 1 )
				return 1;
			else
				return 0;
		}
	}

	return 0;
}
int PLAYER::checkCommand2(void)
{
	if( getPadNum() >= player_num )					// Q[pbhڑĂȂ
	{
		return getPadState( player_num, PAD_BUTTON2 );
	}
	else
	{
		if( player_num == 1 )
		{
			if( getKeyState( KEY_INPUT_D ) == 1 )
				return 1;
			else
				return 0;
		}
		else
		{
			if( getKeyState( KEY_INPUT_RIGHT ) == 1 )
				return 1;
			else
				return 0;
		}
	}

	return 0;
}
int PLAYER::checkCommand3(void)
{
	if( getPadNum() >= player_num )					// Q[pbhڑĂȂ
	{
		return getPadState( player_num, PAD_BUTTON3 );
	}
	else
	{
		if( player_num == 1 )
		{
			if( getKeyState( KEY_INPUT_S ) == 1 )
				return 1;
			else
				return 0;
		}
		else
		{
			if( getKeyState( KEY_INPUT_DOWN ) == 1 )
				return 1;
			else
				return 0;
		}
	}

	return 0;
}
int PLAYER::checkCommand4(void)
{
	if( getPadNum() >= player_num )					// Q[pbhڑĂȂ
	{
		return getPadState( player_num, PAD_BUTTON4 );
	}
	else
	{
		if( player_num == 1 )
		{
			if( getKeyState( KEY_INPUT_A ) == 1 )
				return 1;
			else
				return 0;
		}
		else
		{
			if( getKeyState( KEY_INPUT_LEFT ) == 1 )
				return 1;
			else
				return 0;
		}
	}

	return 0;
}

/*------------------------------
 * ֐ PLAYER::getAttack
 * Ȃ̍UĂ邩Ԃ
------------------------------*/
int PLAYER::getWaza(void)
{
	int tmp = waza;					// ꎞIɕϐL
	waza = -1;						// U܂I

	return tmp;
}
/*------------------------------
 * ֐ PLAYER::defenceThis
 * U󂯂(H킯ł͂Ȃ)
------------------------------*/
// ₷悤Ƀe[u݂
#define WAZA_TABLE_KIND				0
#define WAZA_TABLE_DAMAGE_H			1
#define WAZA_TABLE_DAMAGE_G			2
#define WAZA_TABLE_DAMAGE_C			3
#define WAZA_TABLE_DAMAGE_Y			4
#define WAZA_TABLE_FLAME_H			5
#define WAZA_TABLE_FLAME_G			6
#define WAZA_TABLE_WHEN_H			7
#define WAZA_TABLE_WHEN_G			8
#define WAZA_TABLE_WHEN_KO			9
#define WAZA_TABLE_STATE			10
const int WAZA_TABLE[4][11] =
{
	// Wu
	{
		ATTACK_KIND_NORMAL,
		DAMAGE_HIT_JAB,
		DAMAGE_GUARD_JAB,
		DAMAGE_CRITICAL_JAB,
		DAMAGE_YARARE_JAB,
		FLAME_ZENTAI_JAB - FLAME_HASSEI_JAB + FLAME_HIT_JAB,
		FLAME_ZENTAI_JAB - FLAME_HASSEI_JAB + FLAME_GUARD_JAB,
		MOVEMENT_YARARE_JAB,
		MOVEMENT_GUARD_JAB,
		MOVEMENT_KO_JAB,
		STATUS_YARARE
	},
	// Xg[g
	{
		ATTACK_KIND_NORMAL,
		DAMAGE_HIT_STRAIGHT,
		DAMAGE_GUARD_STRAIGHT,
		DAMAGE_CRITICAL_STRAIGHT,
		DAMAGE_YARARE_STRAIGHT,
		FLAME_ZENTAI_STRAIGHT - FLAME_HASSEI_STRAIGHT + FLAME_HIT_STRAIGHT,
		FLAME_ZENTAI_STRAIGHT - FLAME_HASSEI_STRAIGHT + FLAME_GUARD_STRAIGHT,
		MOVEMENT_YARARE_STRAIGHT,
		MOVEMENT_GUARD_STRONG,
		MOVEMENT_KO_STRAIGHT,
		STATUS_YARARE,
	},
	// tbN
	{
		ATTACK_KIND_CANTGUARD,
		DAMAGE_HIT_HOOK,
		-1,
		DAMAGE_CRITICAL_HOOK,
		DAMAGE_YARARE_HOOK,
		FLAME_ZENTAI_HOOK - FLAME_HASSEI_HOOK + FLAME_HIT_HOOK,
		-1,
		MOVEMENT_YARARE_HOOK,
		-1,
		MOVEMENT_KO_HOOK,
		STATUS_YARARE
	},
	// Abp[Jbg
	{
		ATTACK_KIND_NORMAL,
		DAMAGE_HIT_UPPERCUT,
		DAMAGE_GUARD_UPPERCUT,
		DAMAGE_CRITICAL_UPPERCUT,
		DAMAGE_YARARE_UPPERCUT,
		FLAME_ZENTAI_UPPERCUT - FLAME_HASSEI_UPPERCUT + FLAME_HIT_UPPERCUT,
		FLAME_ZENTAI_UPPERCUT - FLAME_HASSEI_UPPERCUT + FLAME_GUARD_UPPERCUT,
		MOVEMENT_YARARE_UPPERCUT,
		MOVEMENT_GUARD_STRONG,
		MOVEMENT_KO_UPPERCUT,
		STATUS_MUTEKI
	}
};
void PLAYER::defenceThis( int att )
{
	int tmp_d, tmp_f, tmp_m, tmp_s;

	if( att == -1 ) return;			// UĂȂꍇ͏I
	if( status == STATUS_MUTEKI ) return; // G̏ꍇ͏I

	// ݂̏Ԃ琔lZo
	if( status == STATUS_CRITICAL )
	{
		tmp_d = WAZA_TABLE[att][WAZA_TABLE_DAMAGE_C]; 
		tmp_f = WAZA_TABLE[att][WAZA_TABLE_FLAME_H]; 
		tmp_m = WAZA_TABLE[att][WAZA_TABLE_WHEN_H];
		tmp_s = WAZA_TABLE[att][WAZA_TABLE_STATE];

		// NeBJ{[iX
		if( player_num == 1 ) player2.setBonus( BONUS_CRITICAL );
		else if( player_num == 2 ) player1.setBonus( BONUS_CRITICAL );
	}
	else if( status == STATUS_YARARE )
	{
		tmp_d = WAZA_TABLE[att][WAZA_TABLE_DAMAGE_Y]; 
		tmp_f = WAZA_TABLE[att][WAZA_TABLE_FLAME_H]; 
		tmp_m = WAZA_TABLE[att][WAZA_TABLE_WHEN_H];
		tmp_s = WAZA_TABLE[att][WAZA_TABLE_STATE];
	}
	/*else if( status == STATUS_AIUCHI )
	{
		tmp_d = WAZA_TABLE[att][WAZA_TABLE_DAMAGE_H]; 
		tmp_f = FLAME_AIUCHI; 
		tmp_m = MOVEMENT_YARARE_AIUCHI;
	}*/
	else if( status != STATUS_GUARD || WAZA_TABLE[att][WAZA_TABLE_KIND] == ATTACK_KIND_CANTGUARD )
	{
		tmp_d = WAZA_TABLE[att][WAZA_TABLE_DAMAGE_H]; 
		tmp_f = WAZA_TABLE[att][WAZA_TABLE_FLAME_H]; 
		tmp_m = WAZA_TABLE[att][WAZA_TABLE_WHEN_H];
		tmp_s = WAZA_TABLE[att][WAZA_TABLE_STATE];
	}
	else
	{
		tmp_d = WAZA_TABLE[att][WAZA_TABLE_DAMAGE_G]; 
		tmp_f = WAZA_TABLE[att][WAZA_TABLE_FLAME_G]; 
		tmp_m = WAZA_TABLE[att][WAZA_TABLE_WHEN_G];	
		tmp_s = STATUS_MUTEKI;
	}

	// _[W^
	decreaseHP( tmp_d );

	// d^̈ڍss
	if( KO_flag )
	{
		// KO
		moveThis( WAZA_TABLE[att][WAZA_TABLE_WHEN_KO], STATUS_MUTEKI );
	}
	else
	{
		kouchoku = tmp_f;
		moveThis( tmp_m, tmp_s );
	}
}
/*------------------------------
 * ֐ PLAYER::decreaseHP
 * HP炷
------------------------------*/
void PLAYER::decreaseHP( int dmg )
{
	if( no_damage ) return;

	HP -= dmg;

	if( HP <= 0 )						// HP[̂ƂKO
	{
		KO_flag = 1;	
		HP = 0;
	}
}
/*------------------------------
 * ֐ PLAYER::decreaseHPsub
 * ԃQ[W炷BQ[ł͈Ӗ͖
------------------------------*/
void PLAYER::decreaseHPsub(void)
{
	if( HPsub > HP ) HPsub -= (double) PLAYER_HP[ player_num-1 ] / 180;
	
	if( HPsub < HP ) HPsub = HP; // C
}

/*------------------------------
 * ֐ PLAYER::getHP
 * ̗͂Ԃ
------------------------------*/
int PLAYER::getHP(void)
{
	return HP;
}
/*------------------------------
 * ֐ PLAYER::getHPf
 * ̗͂Ԃ(double^)
------------------------------*/
double PLAYER::getHPf(void)
{
	return (double)HP / PLAYER_HP[ player_num-1 ];
}
/*------------------------------
 * ֐ PLAYER::getHPsubf
 * FQ[WԂ(double^)
------------------------------*/
double PLAYER::getHPsubf(void)
{
	return (double)HPsub / PLAYER_HP[ player_num-1 ];
}
int PLAYER::getKO(void)
{
	return KO_flag;
}


/*------------------------------
 * ֐ PLAYER::setCantMove
 * 悤ɂorȂ
------------------------------*/
void PLAYER::setCantMove( int x )
{
	cant_move = x;
}
/*------------------------------
 * ֐ PLAYER::setNoDamage
 * 炤orHȂ悤ɂ
------------------------------*/
void PLAYER::setNoDamage( int x )
{
	no_damage = x;
}



/*------------------------------
 * ֐ PLAYER::soundSE
 * 󋵂ɉēK؂ȉo
------------------------------*/
void PLAYER::soundSE(void)
{
	// Wu炢
	if( ( move == MOVEMENT_YARARE_JAB || move == MOVEMENT_KO_JAB ) && time == 0 )
		PlaySoundMem( SE[ SE_JAB ] , DX_PLAYTYPE_BACK );
	// Xg[g炢
	else if( ( move == MOVEMENT_YARARE_STRAIGHT || move == MOVEMENT_KO_STRAIGHT ) && time == 0 )
		PlaySoundMem( SE[ SE_STRAIGHT ] , DX_PLAYTYPE_BACK );
	// tbN炢
	else if( ( move == MOVEMENT_YARARE_HOOK || move == MOVEMENT_KO_HOOK ) && time == 0 )
		PlaySoundMem( SE[ SE_HOOK ] , DX_PLAYTYPE_BACK );
	// Abp[炢
	else if( ( move == MOVEMENT_YARARE_UPPERCUT || move == MOVEMENT_KO_UPPERCUT ) && time == 0 )
		PlaySoundMem( SE[ SE_UPPER ] , DX_PLAYTYPE_BACK );
	// 
	else if( move == MOVEMENT_ATTACK_UPPERCUT && time == 0 )
		PlaySoundMem( SE[ SE_UPPERAIR ] , DX_PLAYTYPE_BACK );
	// K[h
	else if( ( move == MOVEMENT_GUARD_JAB || move == MOVEMENT_GUARD_STRONG ) && time == 0 )
		PlaySoundMem( SE[ SE_GUARD ] , DX_PLAYTYPE_BACK );
	// _E
	else if
		(
			( move == MOVEMENT_KO_JAB && time == 50 ) ||
			( move == MOVEMENT_KO_STRAIGHT && time == 15 ) ||
			( move == MOVEMENT_KO_HOOK && time == 64 ) ||
			( ( move == MOVEMENT_YARARE_UPPERCUT || move == MOVEMENT_KO_UPPERCUT ) && time == 57 )
		)
		PlaySoundMem( SE[ SE_DOWN ] , DX_PLAYTYPE_BACK );
}
/*------------------------------
 * ֐ PLAYER::setCameraEff
 * 󋵂ɉēK؂ȃGtFNgo
------------------------------*/
void PLAYER::drawEffect(void)
{
	if( !SHOW_EFFECT ) return;

	const int KEI = 16;					// GtFNg̎
	const double POSZ[2] = { 2.0f, -2.0f };

	// qbgGtFNg
	if
	(
		( move == MOVEMENT_YARARE_JAB || move == MOVEMENT_KO_JAB || move == MOVEMENT_YARARE_UPPERCUT || move == MOVEMENT_KO_UPPERCUT || move == MOVEMENT_YARARE_STRAIGHT || move == MOVEMENT_KO_STRAIGHT )
		&&
		( 0 <= time && time <= KEI )
	)
		DrawBillboard3D( VGet( 0.0f, 10.5f, POSZ[ player_num-1 ] ), 0.5f, 0.5f, 7.5f, 0.0f, hitEffect[ EFF_NUM * time / KEI ], TRUE );
		//DrawGraph( POSX[ player_num-1 ] - 100, POSY[0] - 100, hitEffect[ EFF_NUM * time / KEI ], TRUE );
	if
	(
		( move == MOVEMENT_YARARE_HOOK || move == MOVEMENT_KO_HOOK )
		&&
		( 0 <= time && time <= KEI )
	)
		DrawBillboard3D( VGet( 0.0f, 9.5f, POSZ[ player_num-1 ] ), 0.5f, 0.5f, 7.5f, 0.0f, hitEffect[ EFF_NUM * time / KEI ], TRUE );


	// K[hGtFNg
	if( ( move == MOVEMENT_GUARD_JAB || move == MOVEMENT_GUARD_STRONG ) && ( 0 <= time && time <= KEI ) )
		DrawBillboard3D( VGet( 0.0f, 10.5f, POSZ[ player_num-1 ] ), 0.5f, 0.5f, 7.5f, 0.0f, grdEffect[ EFF_NUM * time / KEI ], TRUE );;
}
/*------------------------------
 * ֐ PLAYER::setCameraEff
 * 󋵂ɉēK؂ȃJ̓
------------------------------*/
void PLAYER::setCameraEff(void)
{
	if( ( move == MOVEMENT_YARARE_UPPERCUT || move == MOVEMENT_KO_UPPERCUT ) && time == 0 ) setCameraState( CAMERA_AIR );
	if( move == MOVEMENT_YARARE_STRAIGHT && time == 0 ) setCameraState( CAMERA_ZOOMIN );
	if( move == MOVEMENT_KO_STRAIGHT && time == 0 ) setCameraState( CAMERA_ZOOMOUT );
	if( move == MOVEMENT_KO_HOOK && time == 0 ) setCameraState( CAMERA_LOOKDOWN );
}

/*------------------------------
 * ֐ PLAYER::cdownBonus
 * {[iX\̊Ǘ
------------------------------*/
void PLAYER::cdownBonus(void)
{
	if( reversal_flag )
	{
		reversal_time++;

		if( reversal_time >= FLAME_BONUS_TIME )
		{
			reversal_flag = 0;
			reversal_time = 0;
		}
	}
	if( critical_flag )
	{
		critical_time++;

		if( critical_time >= FLAME_BONUS_TIME )
		{
			critical_flag = 0;
			critical_time = 0;
		}
	}
}
void PLAYER::setBonus( int x )
{
	if( x == BONUS_REVERSAL )
	{
		reversal_flag = 1;
		reversal_time = 0;		
	}
	if( x == BONUS_CRITICAL )
	{
		critical_flag = 1;
		critical_time = 0;	
	}
}
int PLAYER::getBonus( int x )
{
	if( x == BONUS_REVERSAL )
		return reversal_flag;
	if( x == BONUS_CRITICAL )
		return critical_flag;

	return -1;
}
int PLAYER::getBonusTime( int x )
{
	if( x == BONUS_REVERSAL )
		return reversal_time;
	if( x == BONUS_CRITICAL )
		return critical_time;

	return -1;
}

/*------------------------------
 * ֐ PLAYER::walk
 * OɓBQ[ɂ͉eȂ
------------------------------*/
void PLAYER::walk(void)
{
	switch( move )								// ݂̏󋵂ɂ, Ăяo֐߂
	{
	case MOVEMENT_ATTACK_JAB:
		if( player_num == 1 )
			fight.movePosition(  0.02f );
		else
			fight.movePosition( -0.02f );		
		break;
	case MOVEMENT_ATTACK_STRAIGHT:
		if( player_num == 1 )
			fight.movePosition( 0.04f );
		else
			fight.movePosition( -0.04f );		
		break;
	case MOVEMENT_ATTACK_UPPERCUT:
		if( time >= 60 ) break;
		if( player_num == 1 )
			fight.movePosition( 0.04f );
		else
			fight.movePosition( -0.04f );		
		break;
	case MOVEMENT_TACHI:
	case MOVEMENT_ATTACK_HOOK:
	case MOVEMENT_YARARE_JAB:
	case MOVEMENT_YARARE_STRAIGHT:
	case MOVEMENT_YARARE_HOOK:
	case MOVEMENT_YARARE_UPPERCUT:
	case MOVEMENT_YARARE_AIUCHI:
	case MOVEMENT_GUARD_JAB:
	case MOVEMENT_KO_JAB:
	case MOVEMENT_KO_STRAIGHT:
	case MOVEMENT_KO_HOOK:
	case MOVEMENT_KO_UPPERCUT:
	default:
		break;
	}
}